;             
CREATE USER IF NOT EXISTS XYZ PASSWORD '' ADMIN;              
CREATE SEQUENCE PUBLIC.SYSTEM_SEQUENCE_8B584365_CD35_4B77_9AA9_5E180A8B3FCA START WITH 8 BELONGS_TO_TABLE;    
CREATE CACHED TABLE PUBLIC.GRUPPE(
    ID INT NOT NULL,
    NAME VARCHAR(25)
);               
ALTER TABLE PUBLIC.GRUPPE ADD CONSTRAINT PUBLIC.CONSTRAINT_2 PRIMARY KEY(ID); 
-- 3 +/- SELECT COUNT(*) FROM PUBLIC.GRUPPE;  
INSERT INTO PUBLIC.GRUPPE(ID, NAME) VALUES
(1, 'Sonstiges'),
(2, 'Obst'),
(3, 'Gemuese');     
CREATE CACHED TABLE PUBLIC.GANG(
    ID INT NOT NULL,
    NAME VARCHAR(25)
); 
ALTER TABLE PUBLIC.GANG ADD CONSTRAINT PUBLIC.CONSTRAINT_3 PRIMARY KEY(ID);   
-- 2 +/- SELECT COUNT(*) FROM PUBLIC.GANG;    
INSERT INTO PUBLIC.GANG(ID, NAME) VALUES
(1, 'A'),
(2, 'B');  
CREATE CACHED TABLE PUBLIC.FACH(
    ID INT NOT NULL,
    NAME VARCHAR(25)
); 
ALTER TABLE PUBLIC.FACH ADD CONSTRAINT PUBLIC.CONSTRAINT_4 PRIMARY KEY(ID);   
-- 4 +/- SELECT COUNT(*) FROM PUBLIC.FACH;    
INSERT INTO PUBLIC.FACH(ID, NAME) VALUES
(1, 'Fach 1'),
(2, 'Fach 2'),
(3, 'Fach 3'),
(4, 'Fach 4');          
CREATE CACHED TABLE PUBLIC.STEUER(
    ID INT NOT NULL,
    NAME VARCHAR(25),
    WERT INT
); 
ALTER TABLE PUBLIC.STEUER ADD CONSTRAINT PUBLIC.CONSTRAINT_5 PRIMARY KEY(ID); 
-- 2 +/- SELECT COUNT(*) FROM PUBLIC.STEUER;  
INSERT INTO PUBLIC.STEUER(ID, NAME, WERT) VALUES
(1, 'MwSt', 7),
(2, 'MwSt', 19);             
CREATE CACHED TABLE PUBLIC.ARTIKEL(
    NRINTERN BIGINT DEFAULT (NEXT VALUE FOR PUBLIC.SYSTEM_SEQUENCE_8B584365_CD35_4B77_9AA9_5E180A8B3FCA) NOT NULL NULL_TO_DEFAULT SEQUENCE PUBLIC.SYSTEM_SEQUENCE_8B584365_CD35_4B77_9AA9_5E180A8B3FCA,
    NREXTERN VARCHAR(25),
    BEZEICHNUNG VARCHAR(10),
    BESCHREIBUNG VARCHAR(100),
    EAN13 VARCHAR(13),
    STEUER_ID INT,
    GRUPPE_ID INT,
    GANG_ID INT,
    REGAL_ID INT,
    FACH_ID INT,
    EK DECIMAL(10, 4) DEFAULT 0,
    VK DECIMAL(10, 4) DEFAULT 0,
    ANZEIGEN BOOLEAN DEFAULT TRUE,
    GESPERRT INT DEFAULT 0
);         
ALTER TABLE PUBLIC.ARTIKEL ADD CONSTRAINT PUBLIC.CONSTRAINT_F PRIMARY KEY(NRINTERN);          
-- 6 +/- SELECT COUNT(*) FROM PUBLIC.ARTIKEL; 
INSERT INTO PUBLIC.ARTIKEL(NRINTERN, NREXTERN, BEZEICHNUNG, BESCHREIBUNG, EAN13, STEUER_ID, GRUPPE_ID, GANG_ID, REGAL_ID, FACH_ID, EK, VK, ANZEIGEN, GESPERRT) VALUES
(1, '001-A001', 'Melone', STRINGDECODE('gro\u00df, w\u00e4\u00dfrig'), '1234567891011', 2, 1, 1, 2, 1, 3.9500, 9.9500, TRUE, 0),
(2, '001-A002', 'Ananas', 'sauer, stachelig', '4234567891011', 2, 1, 1, 2, 4, 0.9500, 4.9500, TRUE, 0),
(4, '001-A003', 'Apfel', STRINGDECODE('rund, gr\u00fcn'), '4234563891011', 2, 1, 2, 1, 1, 1000.0000, 1250.0000, TRUE, 0),
(5, '001-A004', 'Birne', 'oval', '4236789103456', 1, 1, 1, 1, 1, 0.1000, 0.4500, TRUE, 0),
(6, '001-A005', 'Banane', 'gebogen', '4236999103456', 1, 1, 1, 1, 1, 0.1000, 0.4500, TRUE, 0),
(7, '001-A006', 'Orange', STRINGDECODE('rund, orange, s\u00fc\u00df, ...'), '4239389103456', 1, 1, 1, 1, 1, 0.1000, 0.4500, TRUE, 0);      
CREATE FORCE VIEW PUBLIC.ALLEARTIKEL(NRINTERN, NREXTERN, BEZEICHNUNG, BESCHREIBUNG, EAN13, STEUER_ID, GRUPPE_ID, GANG_ID, REGAL_ID, FACH_ID, EK, VK, ANZEIGEN, GESPERRT, FACH_NAME, GANG_NAME, GRUPPE_NAME, REGAL_NAME, STEUER_NAME, STEUER_WERT) AS
SELECT
    ARTIKEL.NRINTERN,
    ARTIKEL.NREXTERN,
    ARTIKEL.BEZEICHNUNG,
    ARTIKEL.BESCHREIBUNG,
    ARTIKEL.EAN13,
    ARTIKEL.STEUER_ID,
    ARTIKEL.GRUPPE_ID,
    ARTIKEL.GANG_ID,
    ARTIKEL.REGAL_ID,
    ARTIKEL.FACH_ID,
    ARTIKEL.EK,
    ARTIKEL.VK,
    ARTIKEL.ANZEIGEN,
    ARTIKEL.GESPERRT,
    FACH.NAME AS FACH_NAME,
    GANG.NAME AS GANG_NAME,
    GRUPPE.NAME AS GRUPPE_NAME,
    REGAL.NAME AS REGAL_NAME,
    STEUER.NAME AS STEUER_NAME,
    STEUER.WERT AS STEUER_WERT
FROM PUBLIC.ARTIKEL
    /* PUBLIC.ARTIKEL.tableScan */
LEFT OUTER JOIN PUBLIC.FACH
    /* PUBLIC.PRIMARY_KEY_20: ID = ARTIKEL.FACH_ID */
    ON FACH.ID = ARTIKEL.FACH_ID
LEFT OUTER JOIN PUBLIC.GANG
    /* PUBLIC.PRIMARY_KEY_2: ID = ARTIKEL.GANG_ID */
    ON GANG.ID = ARTIKEL.GANG_ID
LEFT OUTER JOIN PUBLIC.REGAL
    /* PUBLIC.PRIMARY_KEY_4: ID = ARTIKEL.GANG_ID */
    ON REGAL.ID = ARTIKEL.GANG_ID
LEFT OUTER JOIN PUBLIC.GRUPPE
    /* PUBLIC.PRIMARY_KEY_7: ID = ARTIKEL.GRUPPE_ID */
    ON GRUPPE.ID = ARTIKEL.GRUPPE_ID
LEFT OUTER JOIN PUBLIC.STEUER
    /* PUBLIC.PRIMARY_KEY_9: ID = ARTIKEL.STEUER_ID */
    ON STEUER.ID = ARTIKEL.STEUER_ID;             
CREATE CACHED TABLE PUBLIC.REGAL(
    ID INT NOT NULL,
    NAME VARCHAR(25)
);
ALTER TABLE PUBLIC.REGAL ADD CONSTRAINT PUBLIC.CONSTRAINT_6 PRIMARY KEY(ID);  
-- 2 +/- SELECT COUNT(*) FROM PUBLIC.REGAL;   
INSERT INTO PUBLIC.REGAL(ID, NAME) VALUES
(1, 'Regal 1'),
(2, 'Regal 2');     
CREATE FORCE VIEW PUBLIC.EINIGEARTIKEL(NRINTERN, NREXTERN, BEZEICHNUNG, BESCHREIBUNG, EAN13, EK, VK, FACH_NAME, GANG_NAME, GRUPPE_NAME, REGAL_NAME, STEUER_WERT, ANZEIGEN) AS
SELECT
    ARTIKEL.NRINTERN,
    ARTIKEL.NREXTERN,
    ARTIKEL.BEZEICHNUNG,
    ARTIKEL.BESCHREIBUNG,
    ARTIKEL.EAN13,
    ARTIKEL.EK,
    ARTIKEL.VK,
    FACH.NAME AS FACH_NAME,
    GANG.NAME AS GANG_NAME,
    GRUPPE.NAME AS GRUPPE_NAME,
    REGAL.NAME AS REGAL_NAME,
    STEUER.WERT AS STEUER_WERT,
    ARTIKEL.ANZEIGEN
FROM PUBLIC.ARTIKEL
    /* PUBLIC.ARTIKEL.tableScan */
LEFT OUTER JOIN PUBLIC.FACH
    /* PUBLIC.PRIMARY_KEY_20: ID = ARTIKEL.FACH_ID */
    ON FACH.ID = ARTIKEL.FACH_ID
LEFT OUTER JOIN PUBLIC.GANG
    /* PUBLIC.PRIMARY_KEY_2: ID = ARTIKEL.GANG_ID */
    ON GANG.ID = ARTIKEL.GANG_ID
LEFT OUTER JOIN PUBLIC.REGAL
    /* PUBLIC.PRIMARY_KEY_4: ID = ARTIKEL.GANG_ID */
    ON REGAL.ID = ARTIKEL.GANG_ID
LEFT OUTER JOIN PUBLIC.GRUPPE
    /* PUBLIC.PRIMARY_KEY_7: ID = ARTIKEL.GRUPPE_ID */
    ON GRUPPE.ID = ARTIKEL.GRUPPE_ID
LEFT OUTER JOIN PUBLIC.STEUER
    /* PUBLIC.PRIMARY_KEY_9: ID = ARTIKEL.STEUER_ID */
    ON STEUER.ID = ARTIKEL.STEUER_ID;        
